###################################################
### chunk number 1: 
###################################################
#line 18 "d:/Rcompile/CRANpkg/local/2.12/ezsim/inst/doc/vignette.Rnw"
library(ezsim)
ezsim_basic<-ezsim(
    m             = 200,
    run           = TRUE,
    core          = 1,
    display_name  = c(mean_hat="hat(mu)",sd_mean_hat="hat(sigma[hat(mu)])"),
    parameter_def = createParDef(list(n=seq(20,80,20),mu=c(0,2),sigma=c(1,3,5))),
    dgp           = function() rnorm(n,mu,sigma),
    estimator     = function(x) c(mean_hat = mean(x), 
                                 sd_mean_hat=sd(x)/sqrt(length(x)-1)),
    true_value    = function() c(mu, sigma / sqrt(n-1))
)


###################################################
### chunk number 2: 
###################################################
#line 31 "d:/Rcompile/CRANpkg/local/2.12/ezsim/inst/doc/vignette.Rnw"
summary(ezsim_basic)


###################################################
### chunk number 3:  eval=FALSE
###################################################
## #line 33 "d:/Rcompile/CRANpkg/local/2.12/ezsim/inst/doc/vignette.Rnw"
## plot(ezsim_basic)
## plot(ezsim_basic,"density")


###################################################
### chunk number 4: 
###################################################
#line 37 "d:/Rcompile/CRANpkg/local/2.12/ezsim/inst/doc/vignette.Rnw"
print(plot(ezsim_basic,return_print=TRUE)[[1]])


###################################################
### chunk number 5: 
###################################################
#line 41 "d:/Rcompile/CRANpkg/local/2.12/ezsim/inst/doc/vignette.Rnw"
print(plot(ezsim_basic,return_print=TRUE)[[2]])


###################################################
### chunk number 6: 
###################################################
#line 45 "d:/Rcompile/CRANpkg/local/2.12/ezsim/inst/doc/vignette.Rnw"
print(plot(ezsim_basic,"density",return_print=TRUE)[[1]])


###################################################
### chunk number 7: 
###################################################
#line 49 "d:/Rcompile/CRANpkg/local/2.12/ezsim/inst/doc/vignette.Rnw"
print(plot(ezsim_basic,"density",return_print=TRUE)[[2]])


###################################################
### chunk number 8: 
###################################################
#line 73 "d:/Rcompile/CRANpkg/local/2.12/ezsim/inst/doc/vignette.Rnw"
par_def<-createParDef(scalars=list(n=seq(20,80,20),mu=c(0,2),sigma=c(1,3,5)))
par_def


###################################################
### chunk number 9: 
###################################################
#line 78 "d:/Rcompile/CRANpkg/local/2.12/ezsim/inst/doc/vignette.Rnw"
generate(par_def)[1:3]


###################################################
### chunk number 10: 
###################################################
#line 83 "d:/Rcompile/CRANpkg/local/2.12/ezsim/inst/doc/vignette.Rnw"
par_def2<-createParDef(scalars=list(mu1=5,mu2=3,n=c(10,20)), others=list(Sigma=matrix(c(1,.4,.4,1),nrow=2)))
generate(par_def2)


###################################################
### chunk number 11: 
###################################################
#line 91 "d:/Rcompile/CRANpkg/local/2.12/ezsim/inst/doc/vignette.Rnw"
dgp<-function(){
	rnorm(n,mu,sigma)
}


###################################################
### chunk number 12: 
###################################################
#line 96 "d:/Rcompile/CRANpkg/local/2.12/ezsim/inst/doc/vignette.Rnw"
test(par_def,dgp,index=1)
test(par_def,dgp,index=2)



###################################################
### chunk number 13: 
###################################################
#line 101 "d:/Rcompile/CRANpkg/local/2.12/ezsim/inst/doc/vignette.Rnw"
dgp_2<-function(){
    z1<-rnorm(n)
    z2<-rnorm(n)
    cbind(x1=mu1+z1*Sigma[1,1], x2=mu2+ Sigma[2,2]*(Sigma[1,2]*z1+ sqrt(1-Sigma[1,2]^2)*z2 ))
}
test(par_def2,dgp_2)



###################################################
### chunk number 14: 
###################################################
#line 112 "d:/Rcompile/CRANpkg/local/2.12/ezsim/inst/doc/vignette.Rnw"
estimator<-function(x){
    c(mean_hat = mean(x), sd_mean_hat=sd(x)/sqrt(length(x)-1))
}
estimator(test(par_def,dgp,index=1))


###################################################
### chunk number 15: 
###################################################
#line 121 "d:/Rcompile/CRANpkg/local/2.12/ezsim/inst/doc/vignette.Rnw"
true<-function(){
    c(mu, sigma / sqrt(n-1))
}
test(par_def,true)


###################################################
### chunk number 16: 
###################################################
#line 130 "d:/Rcompile/CRANpkg/local/2.12/ezsim/inst/doc/vignette.Rnw"
display_name<-c(mean_hat="hat(mu)",sd_mean_hat="hat(sigma[hat(mu)])")


###################################################
### chunk number 17: 
###################################################
#line 139 "d:/Rcompile/CRANpkg/local/2.12/ezsim/inst/doc/vignette.Rnw"
summary(ezsim_basic,subset=list(estimator="mean_hat",n=c(20,40),sigma=c(1,3)))


###################################################
### chunk number 18: 
###################################################
#line 144 "d:/Rcompile/CRANpkg/local/2.12/ezsim/inst/doc/vignette.Rnw"
summary(ezsim_basic,simple=FALSE,subset=list(estimator="mean_hat",n=c(20,40),sigma=c(1,3)))


###################################################
### chunk number 19: 
###################################################
#line 149 "d:/Rcompile/CRANpkg/local/2.12/ezsim/inst/doc/vignette.Rnw"
summary(ezsim_basic,stat=c("q25","median","q75"),Q025=quantile(value_of_estimator,0.025),Q975=quantile(value_of_estimator,0.975),subset=list(estimator="mean_hat",n=c(20,40),sigma=c(1,3)))


###################################################
### chunk number 20:  eval=FALSE
###################################################
## #line 159 "d:/Rcompile/CRANpkg/local/2.12/ezsim/inst/doc/vignette.Rnw"
## plot(ezsim_basic,subset=list(estimator="sd_mean_hat",mu=3))


###################################################
### chunk number 21: 
###################################################
#line 161 "d:/Rcompile/CRANpkg/local/2.12/ezsim/inst/doc/vignette.Rnw"
print(plot(ezsim_basic,subset=list(estimator="sd_mean_hat",mu=0),return_print=TRUE)[[1]])



###################################################
### chunk number 22:  eval=FALSE
###################################################
## #line 164 "d:/Rcompile/CRANpkg/local/2.12/ezsim/inst/doc/vignette.Rnw"
## plot(ezsim_basic,subset=list(estimator="mean_hat",sigma=3))


###################################################
### chunk number 23: 
###################################################
#line 166 "d:/Rcompile/CRANpkg/local/2.12/ezsim/inst/doc/vignette.Rnw"
print(plot(ezsim_basic,subset=list(estimator="mean_hat",sigma=3),return_print=TRUE)[[1]])


###################################################
### chunk number 24:  eval=FALSE
###################################################
## #line 172 "d:/Rcompile/CRANpkg/local/2.12/ezsim/inst/doc/vignette.Rnw"
## plot(ezsim_basic,subset=list(estimator="sd_mean_hat",mu=0),parameters_priority=c("sigma","n"))


###################################################
### chunk number 25: 
###################################################
#line 174 "d:/Rcompile/CRANpkg/local/2.12/ezsim/inst/doc/vignette.Rnw"
print(plot(ezsim_basic,subset=list(estimator="sd_mean_hat",mu=0),parameters_priority="sigma",return_print=TRUE)[[1]])




###################################################
### chunk number 26:  eval=FALSE
###################################################
## #line 178 "d:/Rcompile/CRANpkg/local/2.12/ezsim/inst/doc/vignette.Rnw"
## plot(ezsim_basic,subset=list(estimator="mean_hat",sigma=c(1,3)),parameters_priority="mu")


###################################################
### chunk number 27: 
###################################################
#line 180 "d:/Rcompile/CRANpkg/local/2.12/ezsim/inst/doc/vignette.Rnw"
print(plot(ezsim_basic,subset=list(estimator="mean_hat",sigma=c(1,3)),parameters_priority="mu",return_print=TRUE)[[1]])



###################################################
### chunk number 28:  eval=FALSE
###################################################
## #line 188 "d:/Rcompile/CRANpkg/local/2.12/ezsim/inst/doc/vignette.Rnw"
## plot(ezsim_basic,"density",subset=list(estimator="mean_hat",sigma=3),parameters_priority="n",benchmark=dnorm)


###################################################
### chunk number 29: 
###################################################
#line 190 "d:/Rcompile/CRANpkg/local/2.12/ezsim/inst/doc/vignette.Rnw"
print(plot(ezsim_basic,"density",benchmark=dnorm,subset=list(estimator="mean_hat",sigma=3),parameters_priority="n",return_print=TRUE)[[1]])




###################################################
### chunk number 30:  eval=FALSE
###################################################
## #line 194 "d:/Rcompile/CRANpkg/local/2.12/ezsim/inst/doc/vignette.Rnw"
## plot(ezsim_basic,"density",subset=list(estimator="mean_hat",mu=0),parameters_priority="n" ,benchmark=dnorm)


###################################################
### chunk number 31: 
###################################################
#line 196 "d:/Rcompile/CRANpkg/local/2.12/ezsim/inst/doc/vignette.Rnw"
print(plot(ezsim_basic,"density",benchmark=dnorm,subset=list(estimator="mean_hat",mu=0),parameters_priority="n",return_print=TRUE)[[1]])


###################################################
### chunk number 32:  eval=FALSE
###################################################
## #line 203 "d:/Rcompile/CRANpkg/local/2.12/ezsim/inst/doc/vignette.Rnw"
## plot(summary(ezsim_basic,c("q25","q75")))


###################################################
### chunk number 33: 
###################################################
#line 205 "d:/Rcompile/CRANpkg/local/2.12/ezsim/inst/doc/vignette.Rnw"
print(plot(summary(ezsim_basic,c("q25","q75")),return_print=TRUE))



###################################################
### chunk number 34:  eval=FALSE
###################################################
## #line 208 "d:/Rcompile/CRANpkg/local/2.12/ezsim/inst/doc/vignette.Rnw"
## plot(summary(ezsim_basic,c("q25","q75"),subset=list(estimator="mean_hat")))


###################################################
### chunk number 35: 
###################################################
#line 210 "d:/Rcompile/CRANpkg/local/2.12/ezsim/inst/doc/vignette.Rnw"
print(plot(summary(ezsim_basic,c("q25","q75"),subset=list(estimator="mean_hat")),return_print=TRUE))



###################################################
### chunk number 36:  eval=FALSE
###################################################
## #line 213 "d:/Rcompile/CRANpkg/local/2.12/ezsim/inst/doc/vignette.Rnw"
## plot(summary(ezsim_basic,c("median"),subset=list(estimator="sd_mean_hat")))


###################################################
### chunk number 37: 
###################################################
#line 215 "d:/Rcompile/CRANpkg/local/2.12/ezsim/inst/doc/vignette.Rnw"
print(plot(summary(ezsim_basic,c("median"),subset=list(estimator="sd_mean_hat")),return_print=TRUE))



###################################################
### chunk number 38: 
###################################################
#line 223 "d:/Rcompile/CRANpkg/local/2.12/ezsim/inst/doc/vignette.Rnw"
ez_powerfun<-ezsim(
    m             = 100,
    run           = TRUE,
    core          = 1,
    display_name  = c(b="beta",es="sigma[e]^2",xs="sigma[x]^2"),
    parameter_def = createParDef(scalars=list(xs=1,n=50,es=5,b=seq(-1,1,0.1))),
    dgp           = function(){
                        x<-rnorm(n,0,xs)
                        e<-rnorm(n,0,es)
                        y<-b * x + e
                        data.frame(y,x)
                    },
    estimator     = function(d){
                        r<-summary(lm(y~x-1,data=d))
                        stat<-r$coef[,1]/r$coef[,2]

                        # test whether b > 0
                        # level of significance : 5%
                        out <- stat > c(qnorm(.95), qt(0.95,df=r$df[2]))
                        names(out)<-c("z-test","t-test")
                        out
                    }
)


###################################################
### chunk number 39:  eval=FALSE
###################################################
## #line 248 "d:/Rcompile/CRANpkg/local/2.12/ezsim/inst/doc/vignette.Rnw"
## plot(ez_powerfun,"powerfun",null_hypothesis=0)
## 


###################################################
### chunk number 40: 
###################################################
#line 251 "d:/Rcompile/CRANpkg/local/2.12/ezsim/inst/doc/vignette.Rnw"
print(plot(ez_powerfun,"powerfun",null_hypothesis=0,return_print=TRUE))


